import sys, os
from solver import Board
from getopt import getopt, GetoptError

def main(argv):
    opts, args = getopt(argv, "?ds", ["help", "describe", "solve"])
    if not opts:
        usage()
        return
    for opt, val in opts:
        if opt in ("-?", "--help"):
            usage()
            return
        elif opt in ("-d", "--describe"):
            b = read_board()
            print b
            print "%d cells must be filled." % b.missing()
            if b.solved():
                print "The puzzle is already complete."
            elif b.solvable():
                print "The puzzle has a unique solution."
            elif b.consistent():
                print "The puzzle has more than one solution."
            else:
                print "The puzzle has no solution as it is contradictory."
                
            #reduce = self.reduceable()
            #if reduce > 0:
            #    print "The puzzle is overdefined by at least %d cells."
        elif opt in ("-s", "--solve"):
            b = read_board()
            print b
            b.solve()
            print b

def read_board():
    matrix = []
    while len(matrix) < 9:
        row = []
        for char in raw_input():
            if char.isdigit(): 
                row.append(int(char))
        if len(row) is 9:
            matrix.append(row)
        elif len(row):
            raise ValueError("9 integers expected, got %d instead on row %d" % (len(row), i))
    return Board(matrix)
      
def usage():
    print """
Sudoku Analyzer and Solver

   (Copyright 2010 by Christoph Burschka. See COPYING.txt for license info.)

Usage:

python main.py <-?|-s|-d>

Options:
    -?, --help
        Show this text
        
    -s, --solve
        Read a puzzle from standard input (see format) and show its solution 
        if it exists.
    
    -d, --describe
        Read a puzzle from standard input and explain how strongly defined it
        is, whether it has a solution and whether that solution is unique.

Format:

    - Nine single digits per line. Non-digit characters are ignored.
    - Unfilled cells *must* be set to 0.
    - One row per line. Separator lines (with no digits) are ignored, but lines
      with digits *must* contain exactly 9 of them.

    - See the sample-*.txt files.
"""

main(sys.argv[1:])
